package foo.bar.tests.dmo._meta;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>_meta.meta_db</code> (previously
 * <code>_meta._db</code>).
 */
public interface MetaDb
extends DataModelObject
{
   /**
    * Getter: Db-name
    * 
    * @return  Db-name
    */
   public character getDbName();

   /**
    * Setter: Db-name
    * 
    * @param   dbName
    *          Db-name
    */
   public void setDbName(Text dbName);

   /**
    * Getter: Db-addr
    * 
    * @return  Db-addr
    */
   public character getDbAddr();

   /**
    * Setter: Db-addr
    * 
    * @param   dbAddr
    *          Db-addr
    */
   public void setDbAddr(Text dbAddr);

   /**
    * Getter: Db-type
    * 
    * @return  Db-type
    */
   public character getDbType();

   /**
    * Setter: Db-type
    * 
    * @param   dbType
    *          Db-type
    */
   public void setDbType(Text dbType);

   /**
    * Getter: Db-comm
    * 
    * @return  Db-comm
    */
   public character getDbComm();

   /**
    * Setter: Db-comm
    * 
    * @param   dbComm
    *          Db-comm
    */
   public void setDbComm(Text dbComm);

   /**
    * Getter: Db-revision
    * 
    * @return  Db-revision
    */
   public integer getDbRevision();

   /**
    * Setter: Db-revision
    * 
    * @param   dbRevision
    *          Db-revision
    */
   public void setDbRevision(NumberType dbRevision);

   /**
    * Indexed Getter: dbMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  dbMisc1
    */
   public integer getDbMisc1(int index);

   /**
    * Indexed Setter: dbMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          dbMisc1
    */
   public void setDbMisc1(int index, NumberType element);

   /**
    * Indexed Getter: dbMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  dbMisc2
    */
   public character getDbMisc2(int index);

   /**
    * Indexed Setter: dbMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          dbMisc2
    */
   public void setDbMisc2(int index, Text element);

   /**
    * Getter: Db-slave
    * 
    * @return  Db-slave
    */
   public logical isDbSlave();

   /**
    * Setter: Db-slave
    * 
    * @param   dbSlave
    *          Db-slave
    */
   public void setDbSlave(logical dbSlave);

   /**
    * Getter: Db-local
    * 
    * @return  Db-local
    */
   public logical isDbLocal();

   /**
    * Setter: Db-local
    * 
    * @param   dbLocal
    *          Db-local
    */
   public void setDbLocal(logical dbLocal);

   /**
    * Indexed Getter: dbRes1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  dbRes1
    */
   public integer getDbRes1(int index);

   /**
    * Indexed Setter: dbRes1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          dbRes1
    */
   public void setDbRes1(int index, NumberType element);

   /**
    * Indexed Getter: dbRes2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  dbRes2
    */
   public character getDbRes2(int index);

   /**
    * Indexed Setter: dbRes2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          dbRes2
    */
   public void setDbRes2(int index, Text element);

   /**
    * Indexed Getter: dbXlate
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 2</code>).
    * 
    * @return  dbXlate
    */
   public raw getDbXlate(int index);

   /**
    * Indexed Setter: dbXlate
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 2</code>).
    * @param   element
    *          dbXlate
    */
   public void setDbXlate(int index, BinaryData element);

   /**
    * Getter: dbXlName
    * 
    * @return  dbXlName
    */
   public character getDbXlName();

   /**
    * Setter: dbXlName
    * 
    * @param   dbXlName
    *          dbXlName
    */
   public void setDbXlName(Text dbXlName);

   /**
    * Indexed Getter: dbCollate
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 10</code>).
    * 
    * @return  dbCollate
    */
   public raw getDbCollate(int index);

   /**
    * Indexed Setter: dbCollate
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 10</code>).
    * @param   element
    *          dbCollate
    */
   public void setDbCollate(int index, BinaryData element);

   /**
    * Getter: dbCollName
    * 
    * @return  dbCollName
    */
   public character getDbCollName();

   /**
    * Setter: dbCollName
    * 
    * @param   dbCollName
    *          dbCollName
    */
   public void setDbCollName(Text dbCollName);

   /**
    * Getter: User-Misc
    * 
    * @return  User-Misc
    */
   public character getUserMisc();

   /**
    * Setter: User-Misc
    * 
    * @param   userMisc
    *          User-Misc
    */
   public void setUserMisc(Text userMisc);

   /**
    * Getter: This is the current globally unique identifier (GUID) for the database to support
    * the aggregation of data across multiple databases. This field is used in all audit related
    * tables to identify which database the audit information is for. All other fields are then
    * only unique within a specific database. Note that the database GUID may change, e.g. through
    * back / restore and copy operations to new databases so careful consideration is required
    * when using it as the foreign key to related tables as joins could be broken / need to be
    * fixed, depending on the nature of the related data. The other way to join from the _db table
    * is via the recid, which never changes but is also not globally unique - so which to use will
    * depend on the related data.
    * 
    * @return  Db guid
    */
   public character getDbGuid();

   /**
    * Setter: This is the current globally unique identifier (GUID) for the database to support
    * the aggregation of data across multiple databases. This field is used in all audit related
    * tables to identify which database the audit information is for. All other fields are then
    * only unique within a specific database. Note that the database GUID may change, e.g. through
    * back / restore and copy operations to new databases so careful consideration is required
    * when using it as the foreign key to related tables as joins could be broken / need to be
    * fixed, depending on the nature of the related data. The other way to join from the _db table
    * is via the recid, which never changes but is also not globally unique - so which to use will
    * depend on the related data.
    * 
    * @param   dbGuid
    *          Db guid
    */
   public void setDbGuid(Text dbGuid);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends MetaDb, Buffer
   {
      /**
       * Getter: dbMisc1
       * 
       * @return  dbMisc1
       */
      public integer[] getDbMisc1();

      /**
       * Indexed Getter: dbMisc1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  dbMisc1
       */
      public integer getDbMisc1(NumberType index);

      /**
       * Indexed Setter: dbMisc1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          dbMisc1
       */
      public void setDbMisc1(NumberType index, NumberType element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: dbMisc1
       * 
       * @param   element
       *          Scalar value to which to set all elements of: dbMisc1
       */
      public void setDbMisc1(NumberType element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: dbMisc1
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: dbMisc1
       */
      public void setDbMisc1(NumberType[] elements);

      /**
       * Getter: dbMisc2
       * 
       * @return  dbMisc2
       */
      public character[] getDbMisc2();

      /**
       * Indexed Getter: dbMisc2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  dbMisc2
       */
      public character getDbMisc2(NumberType index);

      /**
       * Indexed Setter: dbMisc2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          dbMisc2
       */
      public void setDbMisc2(NumberType index, Text element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: dbMisc2
       * 
       * @param   element
       *          Scalar value to which to set all elements of: dbMisc2
       */
      public void setDbMisc2(Text element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: dbMisc2
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: dbMisc2
       */
      public void setDbMisc2(Text[] elements);

      /**
       * Getter: dbRes1
       * 
       * @return  dbRes1
       */
      public integer[] getDbRes1();

      /**
       * Indexed Getter: dbRes1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  dbRes1
       */
      public integer getDbRes1(NumberType index);

      /**
       * Indexed Setter: dbRes1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          dbRes1
       */
      public void setDbRes1(NumberType index, NumberType element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: dbRes1
       * 
       * @param   element
       *          Scalar value to which to set all elements of: dbRes1
       */
      public void setDbRes1(NumberType element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: dbRes1
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: dbRes1
       */
      public void setDbRes1(NumberType[] elements);

      /**
       * Getter: dbRes2
       * 
       * @return  dbRes2
       */
      public character[] getDbRes2();

      /**
       * Indexed Getter: dbRes2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  dbRes2
       */
      public character getDbRes2(NumberType index);

      /**
       * Indexed Setter: dbRes2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          dbRes2
       */
      public void setDbRes2(NumberType index, Text element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: dbRes2
       * 
       * @param   element
       *          Scalar value to which to set all elements of: dbRes2
       */
      public void setDbRes2(Text element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: dbRes2
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: dbRes2
       */
      public void setDbRes2(Text[] elements);

      /**
       * Getter: dbXlate
       * 
       * @return  dbXlate
       */
      public raw[] getDbXlate();

      /**
       * Indexed Getter: dbXlate
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 2</code>).
       * 
       * @return  dbXlate
       */
      public raw getDbXlate(NumberType index);

      /**
       * Indexed Setter: dbXlate
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 2</code>).
       * @param   element
       *          dbXlate
       */
      public void setDbXlate(NumberType index, BinaryData element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: dbXlate
       * 
       * @param   element
       *          Scalar value to which to set all elements of: dbXlate
       */
      public void setDbXlate(BinaryData element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: dbXlate
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: dbXlate
       */
      public void setDbXlate(BinaryData[] elements);

      /**
       * Getter: dbCollate
       * 
       * @return  dbCollate
       */
      public raw[] getDbCollate();

      /**
       * Indexed Getter: dbCollate
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 10</code>).
       * 
       * @return  dbCollate
       */
      public raw getDbCollate(NumberType index);

      /**
       * Indexed Setter: dbCollate
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 10</code>).
       * @param   element
       *          dbCollate
       */
      public void setDbCollate(NumberType index, BinaryData element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: dbCollate
       * 
       * @param   element
       *          Scalar value to which to set all elements of: dbCollate
       */
      public void setDbCollate(BinaryData element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: dbCollate
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: dbCollate
       */
      public void setDbCollate(BinaryData[] elements);

   }
}
