package foo.bar.tests.dmo._meta;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>_meta.meta_index_field</code> (previously
 * <code>_meta._index-field</code>).
 */
public interface MetaIndexField
extends DataModelObject
{
   /**
    * Getter: Index-recid
    * 
    * @return  Index-recid
    */
   public integer getIndexRecid();

   /**
    * Setter: Index-recid
    * 
    * @param   indexRecid
    *          Index-recid
    */
   public void setIndexRecid(NumberType indexRecid);

   /**
    * Getter: Index-Seq
    * 
    * @return  Index-Seq
    */
   public integer getIndexSeq();

   /**
    * Setter: Index-Seq
    * 
    * @param   indexSeq
    *          Index-Seq
    */
   public void setIndexSeq(NumberType indexSeq);

   /**
    * Getter: Field-recid
    * 
    * @return  Field-recid
    */
   public integer getFieldRecid();

   /**
    * Setter: Field-recid
    * 
    * @param   fieldRecid
    *          Field-recid
    */
   public void setFieldRecid(NumberType fieldRecid);

   /**
    * Getter: Ascending
    * 
    * @return  Ascending
    */
   public logical isAscending();

   /**
    * Setter: Ascending
    * 
    * @param   ascending
    *          Ascending
    */
   public void setAscending(logical ascending);

   /**
    * Getter: Abbreviate
    * 
    * @return  Abbreviate
    */
   public logical isAbbreviate();

   /**
    * Setter: Abbreviate
    * 
    * @param   abbreviate
    *          Abbreviate
    */
   public void setAbbreviate(logical abbreviate);

   /**
    * Getter: Unsorted
    * 
    * @return  Unsorted
    */
   public logical isUnsorted();

   /**
    * Setter: Unsorted
    * 
    * @param   unsorted
    *          Unsorted
    */
   public void setUnsorted(logical unsorted);

   /**
    * Indexed Getter: ifMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  ifMisc1
    */
   public integer getIfMisc1(int index);

   /**
    * Indexed Setter: ifMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          ifMisc1
    */
   public void setIfMisc1(int index, NumberType element);

   /**
    * Indexed Getter: ifMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  ifMisc2
    */
   public character getIfMisc2(int index);

   /**
    * Indexed Setter: ifMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          ifMisc2
    */
   public void setIfMisc2(int index, Text element);

   /**
    * Indexed Getter: ifRes1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  ifRes1
    */
   public integer getIfRes1(int index);

   /**
    * Indexed Setter: ifRes1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          ifRes1
    */
   public void setIfRes1(int index, NumberType element);

   /**
    * Indexed Getter: ifRes2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  ifRes2
    */
   public character getIfRes2(int index);

   /**
    * Indexed Setter: ifRes2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          ifRes2
    */
   public void setIfRes2(int index, Text element);

   /**
    * Getter: User-Misc
    * 
    * @return  User-Misc
    */
   public character getUserMisc();

   /**
    * Setter: User-Misc
    * 
    * @param   userMisc
    *          User-Misc
    */
   public void setUserMisc(Text userMisc);

   /**
    * Getter: lastModified
    * 
    * @return  lastModified
    */
   public datetimetz getLastModified();

   /**
    * Setter: lastModified
    * 
    * @param   lastModified
    *          lastModified
    */
   public void setLastModified(date lastModified);

   /**
    * Getter: modSequence
    * 
    * @return  modSequence
    */
   public integer getModSequence();

   /**
    * Setter: modSequence
    * 
    * @param   modSequence
    *          modSequence
    */
   public void setModSequence(NumberType modSequence);

   /**
    * Getter: Collation
    * 
    * @return  Collation
    */
   public character getCollation();

   /**
    * Setter: Collation
    * 
    * @param   collation
    *          Collation
    */
   public void setCollation(Text collation);

   /**
    * Getter: collStrength
    * 
    * @return  collStrength
    */
   public integer getCollStrength();

   /**
    * Setter: collStrength
    * 
    * @param   collStrength
    *          collStrength
    */
   public void setCollStrength(NumberType collStrength);

   /**
    * Getter: KeyValue-expr
    * 
    * @return  KeyValue-expr
    */
   public character getKeyvalueExpr();

   /**
    * Setter: KeyValue-expr
    * 
    * @param   keyvalueExpr
    *          KeyValue-expr
    */
   public void setKeyvalueExpr(Text keyvalueExpr);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends MetaIndexField, Buffer
   {
      /**
       * Getter: ifMisc1
       * 
       * @return  ifMisc1
       */
      public integer[] getIfMisc1();

      /**
       * Indexed Getter: ifMisc1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  ifMisc1
       */
      public integer getIfMisc1(NumberType index);

      /**
       * Indexed Setter: ifMisc1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          ifMisc1
       */
      public void setIfMisc1(NumberType index, NumberType element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: ifMisc1
       * 
       * @param   element
       *          Scalar value to which to set all elements of: ifMisc1
       */
      public void setIfMisc1(NumberType element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: ifMisc1
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: ifMisc1
       */
      public void setIfMisc1(NumberType[] elements);

      /**
       * Getter: ifMisc2
       * 
       * @return  ifMisc2
       */
      public character[] getIfMisc2();

      /**
       * Indexed Getter: ifMisc2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  ifMisc2
       */
      public character getIfMisc2(NumberType index);

      /**
       * Indexed Setter: ifMisc2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          ifMisc2
       */
      public void setIfMisc2(NumberType index, Text element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: ifMisc2
       * 
       * @param   element
       *          Scalar value to which to set all elements of: ifMisc2
       */
      public void setIfMisc2(Text element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: ifMisc2
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: ifMisc2
       */
      public void setIfMisc2(Text[] elements);

      /**
       * Getter: ifRes1
       * 
       * @return  ifRes1
       */
      public integer[] getIfRes1();

      /**
       * Indexed Getter: ifRes1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  ifRes1
       */
      public integer getIfRes1(NumberType index);

      /**
       * Indexed Setter: ifRes1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          ifRes1
       */
      public void setIfRes1(NumberType index, NumberType element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: ifRes1
       * 
       * @param   element
       *          Scalar value to which to set all elements of: ifRes1
       */
      public void setIfRes1(NumberType element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: ifRes1
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: ifRes1
       */
      public void setIfRes1(NumberType[] elements);

      /**
       * Getter: ifRes2
       * 
       * @return  ifRes2
       */
      public character[] getIfRes2();

      /**
       * Indexed Getter: ifRes2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  ifRes2
       */
      public character getIfRes2(NumberType index);

      /**
       * Indexed Setter: ifRes2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          ifRes2
       */
      public void setIfRes2(NumberType index, Text element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: ifRes2
       * 
       * @param   element
       *          Scalar value to which to set all elements of: ifRes2
       */
      public void setIfRes2(Text element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: ifRes2
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: ifRes2
       */
      public void setIfRes2(Text[] elements);

   }
}
